CON
  _clkmode = xtal1 + pll16x        
  _xinfreq = 5_000_000             
  pinLCD = 0
  

VAR
  long  temperatur
  Byte  tensValue
  Byte  onesValue
  long Stack[9]
  long status
  long stackx[9]
  byte hour, minute, second, day, month, year, dow
  byte cmd, out
  byte data[12]
  
   
OBJ
  
  Temperature : "DS1620"
  'Debug  : "FullDuplexSerial"
  LCD    : "FullDuplexSerialPlus"
  SN    : "Simple_Numbers"
  rtc   : "DS1302_full"
  'debug : "SerialMirror"
  'sett  : "set"
  
  

PUB start
dira[7] := 0

lcdinit
rtc.init( 5, 4, 6 ) 

rtc.config


Temperature.Start(1,2,3)




'rtc.setDatetime( 09, 22, 09, 3, 20, 58, 40 )

repeat

'PUB main

  tid
  waitcnt (10_000_000 +cnt)

  hamtatemp
  waitcnt (10_000_000 +cnt)
  present
  waitcnt (10_000_000 +cnt)
  watchbutton



PUB watchbutton



  if ina[7] == 1
    sethour
  'else

    'main
  
    
      
                

PUB tid

      
  
     
    rtc.readTime( @hour, @minute, @second )     
    rtc.readDate( @day, @month, @year, @dow )   
    
    
return
    
  
PUB hamtatemp
  
    
    temperatur := Temperature.gettempc
    
    tensValue := (temperatur/100)
    onesValue := (temperatur/10)-((temperatur/100)*10)
return



PUB lcdinit
LCD.start(24, pinLCD, 0, 19200)
LCD.tx(21)
LCD.tx(12)
waitcnt (30_000_000 +cnt)

LCD.tx(17)
LCD.tx(22)

'LCD.str (string("LCD Init done."))
return

PUB present

LCD.tx(135)

lcd.dec (tensValue)
lcd.dec (onesValue)
lcd.str (string ("c"))

LCD.tx(152)



    LCD.str( SN.decx(hour,2) )
    lcd.str (string (":"))
    
    LCD.str( SN.decx(minute,2) )
    lcd.str (string (":"))
    LCD.str( SN.decx(second,2) )
waitcnt (30_000_000 +cnt)

return





PUB sethour
LCD.tx (12)
waitcnt (10_000_000 +cnt)

LCD.str (string("  Timeset mode"))
LCD.tx (148)
LCD.str (string("   Please wait"))
hour := 0
minute := 0

waitcnt (30_000_000 +cnt)
LCD.tx (12)
waitcnt (10_000_000 +cnt)
LCD.str (string("Enter hour value"))
LCD.tx (148)
LCD.str(SN.decx(minute,2))

dira[7] := 0

repeat
  if ina[7] == 1
      waitcnt (50_000_000 +cnt)
      if ina[7] == 1
        setmin
  
      
     hour := hour +1
          LCD.tx(148)
         LCD.str( SN.decx(hour,2) )
          waitcnt (30_000_000 +cnt)

PUB setmin
LCD.tx (12)
waitcnt (20_000_000 +cnt)

LCD.str (string("Enter min. value"))
LCD.tx (148)
LCD.str(SN.decx(minute,2))

repeat
    if ina[7] == 1
      waitcnt (50_000_000 +cnt)
      if ina[7] == 1
        finalsetting
  
      minute := minute + 1
        LCD.tx(148)
        LCD.str(SN.decx(minute,2))
        waitcnt(30_000_000 +cnt)
      
  

    




pub finalsetting

LCD.tx (12)
waitcnt (30_000_000 +cnt)

LCD.str( SN.decx(hour,2) )
    lcd.str (string (":"))
    
    LCD.str( SN.decx(minute,2) )
LCD.tx (148)

LCD.str (string ("Press to start"))

waitcnt (50_000_000 +cnt)

repeat

  if ina[7] ==1

   
   
    rtc.setDatetime( 09, 22, 09, 3, hour, minute, 00 )

   LCD.tx (12)
   waitcnt (10_000_000 +cnt)
    'main



 